<?php

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
	'SgYoutube',
	'Youtube',
	[
		\SGalinski\SgYoutube\Controller\YoutubeController::class => 'index',
	]
);

// include Plugin sg_twitter
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
	'@import "EXT:sg_youtube/Configuration/TsConfig/Page/NewContentElementWizard.tsconfig"'
);

// Caching
$GLOBALS['TYPO3_CONF_VARS']['SYS']['caching']['cacheConfigurations']['sgyoutube_cache'] ??= [];

// Hooks
$currentTypo3Version = TYPO3\CMS\Core\Utility\VersionNumberUtility::getCurrentTypo3Version();
if (version_compare($currentTypo3Version, '12.0.0', '<')) {
	$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['cms/layout/class.tx_cms_layout.php']['tt_content_drawItem']['sg_youtube']
		= \SGalinski\SgYoutube\Hooks\PageLayoutView\PluginRenderer::class;
}

// License check hook
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['typo3/backend.php']['constructPostProcess'][] =
	\SGalinski\SgYoutube\Hooks\LicenceCheckHook::class . '->performLicenseCheck';

// Add licenceCheck RenderType
$GLOBALS['TYPO3_CONF_VARS']['SYS']['formEngine']['nodeRegistry'][] = [
	'nodeName' => 'SgYoutubeLicenceCheck',
	'priority' => 40,
	'class' => \SGalinski\SgYoutube\Form\Element\LicenceStatus::class,
];
